using System;
using System.Collections;
using System.Diagnostics;
using System.Reflection;
using System.Resources;


namespace NetLauncher
{
	/// <summary>
	/// Web̃AZuƁÃAZuQƂĂAZũLbV𐧌䂷B
	/// </summary>
	public class AssemblyFile : WebFile
	{
		string remoteDirectory;
		string fileName;
		string[] hosts;

		public AssemblyFile(string initFileName, string initLocalDirectory, string initRemoteDirectory, ICollection initHosts)
			: base(initFileName, initLocalDirectory)
		{
			Debug.Assert(initHosts != null && initHosts.Count > 0);

			remoteDirectory = initRemoteDirectory;
			fileName = initFileName;
			hosts = new string[initHosts.Count];
			initHosts.CopyTo(hosts, 0);
		}

		/// <summary>
		/// AZu̓t[gƔrB[g̓tVtrueԂB
		/// </summary>
		/// <exception cref="System.Net.WebException">[gƂ̒ʐMɎsꍇɃX[B</exception>
		new public bool NeedUpdate
		{
			get
			{
				bool result = !localFile.Exists;
				System.Net.WebException excep = null;
				UriBuilder ub = new UriBuilder();
				ub.Scheme = Uri.UriSchemeHttp;
				ub.Path = remoteDirectory + "/" + fileName;
				foreach (string host in hosts)
				{
					try
					{
						ub.Host = host;
						result = base.NeedUpdate(ub.Uri);
						if (!result)
						{
							LoadModules(ub);
						}
						excep = null;
						break;
					}
					catch (System.Net.WebException e)
					{
						excep = e;
					}
				}
				if (excep != null)
				{
					throw excep;
				}
				return result;
			}
		}

		/// <summary>
		/// CƂȂAZuƊ֘AAZu_E[hB
		/// </summary>
		/// <exception cref="System.Net.WebException">[gƂ̒ʐMɎsꍇɃX[B</exception>
		/// <exception cref="System.BadImageFormatException">wt@CȃAZuł͂ȂB</exception>
		public void Download()
		{
			System.Net.WebException excep = null;
			UriBuilder ub = new UriBuilder();
			ub.Scheme = Uri.UriSchemeHttp;
			ub.Path = remoteDirectory + "/" + fileName;
			foreach (string host in hosts)
			{
				ub.Host = host;
				try
				{
					Replace(ub.Uri, false);
					excep = null;
					break;
				}
				catch (System.Net.WebException e)
				{
					excep = e;
				}
			}
			if (excep != null)
			{
				throw excep;
			}
			LoadModules(ub);
		}

		/// <summary>
		/// ̃AZuɊ֘AtꂽC̃[WACRԂB
		/// AZu܂_E[hĂȂꍇɂnullԂB
		/// </summary>
		public System.Drawing.Icon Icon
		{
			///
			get
			{
				System.Drawing.Icon icon = null;
				if (localFile.Exists)
				{
					/*
					 * }l[WhR[h̏ꍇAIFormɃACRݒ肵ĂꍇɊւĂ͈ȉ̕@Ŏ擾\B
					 * Ⴆ΁ANetLauncher.exȅꍇALauncherFormɃACRݒ肵Ă̂
					 * Assembly asm = Assembly.LoadFrom("NetLauncher.exe"); // AZu[hB
					 * ResourceManager rm = new ResourceManager("NetLauncher.LauncherForm", asm); // YAZũtH[\[X擾
					 * Icon icon = (Icon)rm.GetObject("$this.Icon");        // tH[̃ACŔA$this.IconƂOŃ\[XB
					 * AAvP[V̂̃ACR͕ʂɃNɐݒ肳邽߁A̕@ł͕K擾łȂB
					 * āAInterop𗘗pB
					 */
					icon = IconLoader.Load(localFile.FullName);
				}
 				return icon;
			}
		}

		/// <summary>
		/// [JfBNgԂB
		/// </summary>
		public string LocalDirectory
		{
			get { return localFile.DirectoryName; }
		}

		// ΏۂƂ͂ȂAZũXg(擪v疳)
		static readonly string[] defaultAssemblies = {
		  "System",		// System.dll, System.Windows.Forms.dll ...
		  "mscorlib",	// CLI core
		  "mscorcfg",	// ?
		  "Microsoft",	// Some Microsoft's assemblies
		  "Crystal",	// Crystal Report
		  "adodb",		// ADO
		};

		static readonly string[] asmExt = { ".exe", ".dll", };

		/// <summary>
		/// ֘AW[_E[hB
		/// ł͖͌A܂łt݂̂ؑΏۂƂB
		/// ̏́ANeedUpdatevpeBDownload\bhĂяo邽߁AԊmɃICȃzXgƂāA
		/// DownloadɐURL̂܂ܗpB
		/// </summary>
		/// <param name="?">݃ICUri</param>
		/// <exception cref="System.BadImageFormatException">wt@CȃAZuł͂Ȃ</exception>
		private void LoadModules(UriBuilder ub)
		{
			Debug.Assert(localFile.Exists);

			Assembly assembly = Assembly.LoadFrom(localFile.FullName);
			AssemblyName[] asnms = assembly.GetReferencedAssemblies();
			foreach (AssemblyName nm in asnms)
			{
				bool found = false;
				string s = nm.Name;
				foreach (string def in defaultAssemblies)
				{
					if (String.CompareOrdinal(def, 0, s, 0, def.Length) == 0) 
					{
						found = true;
						break;
					}
				}
				if (!found)
				{
					LoadReferencedAssembly(s, ub);
				}
			}
		}

		private void LoadReferencedAssembly(string name, UriBuilder ub)
		{
			System.Net.WebException excep = null;
			foreach (string ext in asmExt)
			{
				ub.Path = remoteDirectory + "/" + name + ext;
				WebFile wf = new WebFile(name + ext, localFile.DirectoryName);
				try
				{
					Uri uri = ub.Uri;
					if (wf.NeedUpdate(uri))
					{
						wf.Replace(uri, false);
					}
					// Ń_E[hꂽDLLDLLQƂĂꍇA
					// ċAIɎQƂĂAZũ_E[hǉB
					return;
				}
				catch (System.Net.WebException e)
				{
					excep = e;
				}
			}
			throw excep;
		}
	}
}
