using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace NetLauncher
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class LauncherForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListView listView;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ImageList imageList;
		private System.Windows.Forms.Label description;
		private System.Windows.Forms.ListView domainView;
		private System.Windows.Forms.ContextMenu domainMenu;
		private System.Windows.Forms.MenuItem domainKill;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Panel panel1;

		private WebLauncher launcher;

		private const int OfflineIcon = 0;

		public LauncherForm(WebLauncher initLauncher)
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
			launcher = initLauncher;
			foreach (WebLauncher.Application app in launcher)
			{
				int index;
				Icon icon = app.Icon;
				if (icon == null)
				{
					index = OfflineIcon;
				}
				else
				{
					index = imageList.Images.Count;
					imageList.Images.Add(icon);
					icon.Dispose();
				}
				ListViewItem vi = new ListViewItem(app.Name, index);
				vi.Tag = app;
				listView.Items.Add(vi);
			}
			launcher.AddOnBeginDownload(new EventHandler(BeginDownload));
			launcher.AddOnEndDownload(new EventHandler(EndDownload));
			launcher.AddOnLoadAppDomain(new EventHandler(LoadAppDomain));
			launcher.AddOnUnloadAppDomain(new EventHandler(UnloadAppDomain));
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				launcher.RemoveOnLoadAppDomain(new EventHandler(LoadAppDomain));
				launcher.RemoveOnUnloadAppDomain(new EventHandler(UnloadAppDomain));
				launcher.RemoveOnBeginDownload(new EventHandler(BeginDownload));
				launcher.RemoveOnEndDownload(new EventHandler(EndDownload));
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(LauncherForm));
			this.listView = new System.Windows.Forms.ListView();
			this.imageList = new System.Windows.Forms.ImageList(this.components);
			this.description = new System.Windows.Forms.Label();
			this.domainView = new System.Windows.Forms.ListView();
			this.domainMenu = new System.Windows.Forms.ContextMenu();
			this.domainKill = new System.Windows.Forms.MenuItem();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.panel1 = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// listView
			// 
			this.listView.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.listView.LargeImageList = this.imageList;
			this.listView.Location = new System.Drawing.Point(24, 40);
			this.listView.MultiSelect = false;
			this.listView.Name = "listView";
			this.listView.Size = new System.Drawing.Size(240, 152);
			this.listView.TabIndex = 0;
			this.listView.DoubleClick += new System.EventHandler(this.listView_DoubleClick);
			this.listView.SelectedIndexChanged += new System.EventHandler(this.listView_SelectedIndexChanged);
			// 
			// imageList
			// 
			this.imageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList.ImageSize = new System.Drawing.Size(32, 32);
			this.imageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList.ImageStream")));
			this.imageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// description
			// 
			this.description.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.description.Location = new System.Drawing.Point(24, 200);
			this.description.Name = "description";
			this.description.Size = new System.Drawing.Size(240, 32);
			this.description.TabIndex = 1;
			// 
			// domainView
			// 
			this.domainView.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.domainView.LargeImageList = this.imageList;
			this.domainView.Location = new System.Drawing.Point(280, 40);
			this.domainView.MultiSelect = false;
			this.domainView.Name = "domainView";
			this.domainView.Size = new System.Drawing.Size(96, 192);
			this.domainView.TabIndex = 2;
			this.domainView.MouseDown += new System.Windows.Forms.MouseEventHandler(this.domainView_MouseDown);
			// 
			// domainMenu
			// 
			this.domainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.domainKill});
			// 
			// domainKill
			// 
			this.domainKill.Index = 0;
			this.domainKill.Text = "I(&E)";
			this.domainKill.Click += new System.EventHandler(this.domainKill_Click);
			// 
			// label1
			// 
			this.label1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.label1.Location = new System.Drawing.Point(296, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 24);
			this.label1.TabIndex = 3;
			this.label1.Text = "ś@@@@@AvP[V";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(200, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "o^ꂽAvP[V";
			// 
			// panel1
			// 
			this.panel1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(264, 232);
			this.panel1.TabIndex = 5;
			// 
			// LauncherForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(392, 246);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.label1,
																		  this.domainView,
																		  this.description,
																		  this.listView,
																		  this.panel1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MinimumSize = new System.Drawing.Size(400, 280);
			this.Name = "LauncherForm";
			this.Text = "NetLauncher";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			WebLauncher launcher = null;
			try
			{
				launcher = new WebLauncher();
			}
			catch (ConfigurationException e)
			{
				MessageBox.Show("\ɃG[܂F" + e.Message, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name);
				return;
			}
			catch (System.Net.WebException)
			{
				MessageBox.Show("ItCłB", System.Reflection.Assembly.GetExecutingAssembly().GetName().Name);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, System.Reflection.Assembly.GetExecutingAssembly().GetName().Name);
				return;
			}
			Application.Run(new LauncherForm(launcher));
		}

		private void listView_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			foreach (ListViewItem vi in listView.SelectedItems)
			{
				WebLauncher.Application app = (WebLauncher.Application)vi.Tag;
				description.Text = app.Description;
			}
		}

		private void listView_DoubleClick(object sender, System.EventArgs e)
		{
			if (listView.SelectedItems.Count > 0)
			{
				ListViewItem vi = listView.SelectedItems[0];
				WebLauncher.Application app = (WebLauncher.Application)vi.Tag;
				// KɍŐVł`FbNׂƂ͌ȂAł͒P̂߁AɃ`FbNsB
				// 炭ŏ̋Nɂ̓`FbNAȍ~̓[JLbVgp̂ǂB
				try
				{
					launcher.Launch(app, true);
				}
				catch (System.Net.WebException ex)
				{
					if (app.CacheExists)
					{
						if (MessageBox.Show("AvP[Ṽ_E[hɎs܂BLbVꂽAvP[Vs܂H", 
							System.Reflection.Assembly.GetExecutingAssembly().GetName().Name, MessageBoxButtons.YesNo) == DialogResult.Yes)
						{
							launcher.LaunchFromLocal(app);
						}
					}
					else
					{
						MessageBox.Show("AvP[Ṽ_E[hɎs܂F" + ex.Message,
							 System.Reflection.Assembly.GetExecutingAssembly().GetName().Name);
					}
				}
			}
		}

		private void LoadAppDomain(object sender, EventArgs arg)
		{
			WebLauncher.AppDomainEventArgs e = (WebLauncher.AppDomainEventArgs)arg;
			string appName = e.AppDomain.FriendlyName;
			ListViewItem item = new ListViewItem(appName, GetImageIndex(appName));
			item.Tag = e.AppDomain;
			if (domainView.InvokeRequired)
			{
				domainView.Invoke(new ListViewDelegate(AddItem), new object[] { item });
			}
			else
			{
				domainView.Items.Add(item);
			}
		}

		private void UnloadAppDomain(object sender, EventArgs arg)
		{
			WebLauncher.AppDomainEventArgs e = (WebLauncher.AppDomainEventArgs)arg;
			foreach (ListViewItem item in domainView.Items)
			{
				AppDomain dom = (AppDomain)item.Tag;
				if (dom == null || dom.Equals(e.AppDomain))
				{
					if (domainView.InvokeRequired)
					{
						domainView.Invoke(new ListViewDelegate(RemoveItem), new object[] { item });
					}
					else
					{
						domainView.Items.Remove(item);
					}
					if (dom == null) 
					{
						continue;
					}
					break;
				}
			}
		}

		private delegate void ListViewDelegate(ListViewItem item);
		private void AddItem(ListViewItem item)
		{
			domainView.Items.Add(item);
		}
		private void RemoveItem(ListViewItem item)
		{
			domainView.Items.Remove(item);
		}

		private void BeginDownload(Object sender, EventArgs arg)
		{
		}

		private void EndDownload(Object sender, EventArgs arg)
		{
			WebLauncher.Application app = ((WebLauncher.DownloadEventArgs)arg).Application;
			string appName = app.Name;
			foreach (ListViewItem itm in listView.Items)
			{
				if (itm.Text == appName)
				{
					Icon ico = app.Icon;
					if (ico != null)
					{
						itm.ImageIndex = imageList.Images.Count;
						imageList.Images.Add(ico);
						ico.Dispose();
					}
				}
			}
		}

		private int GetImageIndex(string appName)
		{
			foreach (ListViewItem itm in listView.Items)
			{
				if (itm.Text == appName)
				{
					return itm.ImageIndex;
				}
			}
			Debug.Assert(false, appName + " not found");
			return OfflineIcon;
		}

		private void domainView_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button != MouseButtons.Right) return;
			ListViewItem item = domainView.GetItemAt(e.X, e.Y);
			if (!item.Selected)
			{
				item.Selected = true;
			}
			if (item != null)
			{
				domainMenu.Show(domainView, new Point(e.X, e.Y));
			}
		}

		private void domainKill_Click(object sender, System.EventArgs e)
		{
			ListViewItem item = domainView.SelectedItems[0];
			AppDomain domain = (AppDomain)item.Tag;
			// AppDomain.Unload͎Ԃ̂ŁA[JXbhɏs킹B
			DomainHandler dh = new DomainHandler(KillDomain);
			dh.BeginInvoke(domain, null, null);
			// AppDomainIUnloadƕێĂAppDomaiñCX^X
			// j󂳂āAUnloadAppDomainCxgʒmɐrłȂȂB
			// AListViewItemdomainView.Items.Remove(item);Ƃč폜
			// domainView_MouseDownCxgnh̕AdomainView
			// ܂item̂ƂĎQƂăNbV^C~OB
			// ̂߁Ałnullݒ肵AWebLanucherUnloadAppDomainCxg
			// ʒmɍ폜B
			item.Tag = null;
		}

		private delegate void DomainHandler(AppDomain dom);
		private void KillDomain(AppDomain dom)
		{
			try
			{
				AppDomain.Unload(dom);
			}
			catch (Exception)
			{
			}
		}
	}
}
