using System;
using System.IO;
using System.Net;

namespace NetLauncher
{
	/// <summary>
	/// WebFile ̊Tv̐łB
	/// </summary>
	public class WebFile
	{
		const int DefaultTimeout = 3000;
		protected FileInfo localFile;

		/// <summary>
		/// w肳ꂽt@CAfBNgŏB
		/// w肳ꂽfBNg݂Ȃ΍쐬B
		/// </summary>
		/// <param name="initName">t@C</param>
		/// <param name="initDirectory">[JfBNg</param>
		public WebFile(string initName, string initDirectory)
		{
			if (!Directory.Exists(initDirectory))
			{
				Directory.CreateDirectory(initDirectory);
			}
			localFile = new FileInfo(initDirectory + "\\" + initName);
		}

		/// <summary>
		/// [J̃tpXԂB
		/// </summary>
		public string LocalFileName
		{
			get { return localFile.FullName; }
		}

		/// <summary>
		/// [Jt@C݂trueԂB
		/// </summary>
		public bool Exists
		{
			get
			{
				return localFile.Exists;
			}
		}

		/// <summary>
		/// w肳ꂽzXg̃t@Cƃ[Jt@C̍XVtrA[ĝقVtrueԂB
		/// [Jt@C݂Ȃꍇɂ́AzXgƂ̒ʐM\ȂtrueԂB
		/// ^pƂāAo[WAbvɎsꍇɂ́AÂt@C֖߂ƂƂŝł΁A
		/// Vǂł͂ȂAقȂ邩ǂŌ؂Ȃ΂ȂȂB
		/// </summary>
		/// <param name="uri">[gt@CURI</param>
		/// <returns>[gt@C̍XVtVtrueԂB</returns>
		/// <exception cref="System.Net.WebException">wzXgƂ̒ʐMɎsꍇɃX[B</exception>
		public bool NeedUpdate(Uri uri)
		{
			bool result = true;
			WebRequest req = WebRequest.Create(uri);
			req.Method = "HEAD";
			req.Timeout = DefaultTimeout;
			req.PreAuthenticate = true;
			req.Credentials = CredentialCache.DefaultCredentials;
			WebResponse resp = null;
			try
			{
				resp = req.GetResponse();
				if (localFile.Exists)
				{
					string date = resp.Headers["Last-Modified"];
					DateTime remoteDate = DateTime.Parse(date);
					DateTime localDate = localFile.LastWriteTime;
					result = remoteDate > localDate;
				}
			}
			finally 
			{
				if (resp != null) resp.Close();
			}
			return result;
		}

		/// <summary>
		/// [Jt@C̓ǂݍݐpXg[擾B
		/// </summary>
		/// <exception cref="FileNotFoundException">t@C݂ȂB</exception>
		public FileStream InputStream
		{
			get 
			{
				return localFile.OpenRead();
			}
		}

		/// <summary>
		/// [Jt@Cw肳ꂽ[gt@CŒuB
		/// </summary>
		/// <param name="uri">[gt@CURI</param>
		/// <param name="backup">obNAbvAusɂ͌ɖ߂ꍇɂtrue</param>
		/// <exception cref="System.Net.WebException">wzXgƂ̒ʐMɎsꍇɃX[B</exception>
		public void Replace(Uri uri, bool backup)
		{
			if (!localFile.Exists)
			{
				backup = false;
			}
			WebRequest req = WebRequest.Create(uri);
			req.Method = "GET";
			req.Timeout = DefaultTimeout;
			req.PreAuthenticate = true;
			req.Credentials = CredentialCache.DefaultCredentials;
			WebResponse resp = null;
			string tempf = null;
			string lastModified = null;
			try
			{
				resp = req.GetResponse();
				Stream stm = resp.GetResponseStream();
				tempf = Path.GetTempFileName();
				using (FileStream dest = new FileStream(tempf, FileMode.Create)) 
				{
				    byte[] buff = new Byte[8000];
					int len = 0;
					while ((len = stm.Read(buff, 0, buff.Length)) > 0)
					{
						dest.Write(buff, 0, len);
					}
				}
				lastModified = resp.Headers["Last-Modified"];
			}
			finally 
			{
				if (resp != null) resp.Close();
			}

			File.SetLastWriteTime(tempf, DateTime.Parse(lastModified));
			if (backup)
			{
				localFile.CopyTo(localFile.FullName + ".backup", true);
			}
			try
			{
				if (localFile.Exists)
				{
					localFile.Delete();
				}
				File.Move(tempf, localFile.FullName);
				// ŐV̏𔽉fB
				localFile.Refresh();
			}
			catch (Exception e)
			{
				if (backup)
				{
					File.Copy(localFile.FullName + ".backup", localFile.FullName, true);
				}
				throw e;
			}
		}
	}
}
